Attribute VB_Name = "BGSBFFPlusM"
'*********************************************************************
'Titolo: BGSBrowseForFolderPlus
'Autore: Giorgio Bernardi
'E-Mail: BGSoftware@hotmail.com
'Data  : Novembre 2000
'Descrizione: Modulo per utilizzare la ricerca per cartelle.
'             Questo Modulo va usato con la classe BGSBrowseForFolderPlus
'             Si Consiglia di utilizzare esclusivamente l'oggetto e non
'             utilizzare le funzioni presenti in questo modulo
'Info:  Potete usare e modificare a piacimento questo codice
'       Codice creato a partire da AdvancedBrowseForFolder
'       By Mauro Rossi. Web: http://www.mauro.sistel.it/
'*********************************************************************

Option Explicit

'**************************************************************************
'VARIABILI E OGGETTI SFRUTTATI  (API, TIPI, ECC...)
'**************************************************************************
Private Type BROWSEINFO         'L'oggetto Browser
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type

Private Type SHITEMID
    cb As Long
    abID As Byte
End Type

Private Type ITEMIDLIST
    mkid As SHITEMID
End Type
'Api Necessarie
Private Declare Function SHBrowseForFolder Lib "shell32.dll" (lpbi As BROWSEINFO) As Long
Private Declare Sub CoTaskMemFree Lib "OLE32.DLL" (ByVal hMem As Long)
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function SHGetSpecialFolderLocation Lib "shell32.dll" (ByVal hwndOwner As Long, ByVal nFolder As Long, pidl As ITEMIDLIST) As Long
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

Private Const WM_USER = &H400&
Private Const MAX_PATH = 256

'Messaggi Inviati dal "Browser"
Private Const BFFM_INITIALIZED = 1          'Inizializzazione
Private Const BFFM_SELCHANGED = 2           'SelezioneCambiata
'Private Const BFFM_VALIDATEFAILED = 3
'Public Const BFFM_VALIDATEFAILEDW = 4&
'
'Messaggi che  possibile inviare al Browser
'Private Const BFFM_SETSTATUSTEXT = (WM_USER + 100)
'Private Const BFFM_ENABLEOK = (WM_USER + 101)       'Rende Possibile la selezione
Private Const BFFM_SETSELECTION = (WM_USER + 102)   'Imposta la cartella
'Private Const BFFM_SETSELECTIONW = (WM_USER + 103&)
'Private Const BFFM_SETSTATUSTEXTW = (WM_USER + 104&)

Public Const BIF_RETURNONLYFSDIRS = &H1&       '// For finding a folder to start document searching
'Public Const BIF_DONTGOBELOWDOMAIN = &H2&      '// For starting the Find Computer
'Public Const BIF_STATUSTEXT = &H4&
'Public Const BIF_RETURNFSANCESTORS = &H8&
'Public Const BIF_EDITBOX = &H10&
'Public Const BIF_VALIDATE = &H20&              'insist on valid result (or CANCEL)
'Public Const BIF_BROWSEFORCOMPUTER = &H1000&   'Ricerca Computers
'Public Const BIF_BROWSEFORPRINTER = &H2000&    'Ricerca Stampanti
Public Const BIF_BROWSEINCLUDEFILES = &H4000&   'Aggiunge La possibilit di selezionare files

'**************************************************************************
'VARIABILI PUBBLICHE UTILIZZATE
'**************************************************************************
Private BFF_Paths() As String           'Le Cartelle o i files Vietati
Private BFF_DoNotAllowPaths As Boolean  'Mi ricorda se devo usare questa caratteristica
Private BFF_MessageBox As String        'Il messaggio da visualizzare se l'utente sceglie una cartella o file vietati
Private BFF_BrowseForFolderInitDir As String    'Indica la cartella dalla quale partire
Private BFF_TempLastPath As String        'Indica l'ultima cartella selezionata durante una richiesta

Public Enum BaseFoldersForBrowsing  'Cartelle Base Da cui far Partire l'albero
    Default = -1
    Desktop
    InternetExplorer
    Programmi
    PannelloDiControllo
    Stampanti
    Documenti
    preferiti
    EsecuzioneAutomatica
    Recenti
    InviaA
    Cestino
    MenuAvvio
    NON_USATO
    NON_USATO2
    Video
    NON_USATO3
    DesktopFolder
    RisorseComputer
    Rete
    RisorseDiRete
    Fonts
    ShellNew
End Enum

'**************************************************************************
'FUNZIONE DA RICHIAMARE
'**************************************************************************
Public Function BrowseForFolder(hWnd As Long, Titolo As String, DefaultPath As String, LimitaA As BaseFoldersForBrowsing, Flags As Long) As String
Dim MyBrowse As BROWSEINFO      'E' il "Browser" che uso
Dim UseCallBack As Boolean      'Mi Indica se devo per forza usare la funzione di CallBack
Dim BasePath As String          'Il percorso base

    'Handle del richiedente
    MyBrowse.hOwner = hWnd
    
    'Impostazione della Limitazione (Base dell'albero delle directory)
    If LimitaA > Default Then
        Dim MyItem As ITEMIDLIST
        Call SHGetSpecialFolderLocation(ByVal hWnd, ByVal LimitaA, MyItem)
        MyBrowse.pidlRoot = MyItem.mkid.cb
    End If
    
    'Impostazione della cartella predefinita
    If DefaultPath <> "" Then
        'Controllo che non termini con una barra
        If Right(DefaultPath, 1) = "\" Then BasePath = Left(DefaultPath, Len(DefaultPath) - 1) Else BasePath = DefaultPath
        'Indico la Cartella dalla quale partire.
        'Questa sar settata dalla funzione di CallBack che risponde
        'all'evento "Inizializzazione di BrowseForFolder"
        BFF_BrowseForFolderInitDir = BasePath
        'Indico se devo utilizzare la funzione di CallBack
        UseCallBack = True
    Else    'Altrimenti setto a 0 la cartella di partenza
        BFF_BrowseForFolderInitDir = ""
    End If
    
    'Vedo se  stata specificata almeno una cartella da non visualizzare
    If BFF_DoNotAllowPaths Then UseCallBack = True
    
    'Indicazione della Richiesta (titolo)
    MyBrowse.lpszTitle = Titolo
    
    'Impostazione delle Flags
    MyBrowse.ulFlags = Flags
    
    'Imposto se devo usare il Listener
    If UseCallBack Then MyBrowse.lpfn = bufferLong(AddressOf BrowseFolderCallbackProc)
    
    '  Visualizza la finestra Browse for Folder
    Dim BrowseResult As Long
    BFF_TempLastPath = 0
    BrowseResult = SHBrowseForFolder(MyBrowse)
    
    'Restituzione del valore ottenuto
    Dim BrowsePath As String    'Buffer
    Dim Chr0 As Long            'Posizione del carattere 0
    
    BrowsePath = Space$(512)
    If SHGetPathFromIDList(ByVal BrowseResult, ByVal BrowsePath) Then
        Chr0 = InStr(BrowsePath, Chr$(0))
        BrowseForFolder = Left(BrowsePath, Chr0 - 1)
    Else    'Tasto Annulla Premuto
        BrowseForFolder = ""
    End If

End Function

Public Sub BFF_SetNotAllowedPaths(ByVal MessageToShow As String, Paths() As String)
Dim d As Long
Dim tempPath As String
ReDim BFF_Paths(-1 To -1)

BFF_DoNotAllowPaths = True
BFF_MessageBox = MessageToShow

For d = 0 To UBound(Paths)
    tempPath = Paths(d)
    If Right(tempPath, 1) = "\" Then tempPath = Left(tempPath, Len(tempPath) - 1)
    Call AddToArray(BFF_Paths, tempPath)
Next d
End Sub

Public Sub BFF_AllowAllPaths()
    BFF_DoNotAllowPaths = False
End Sub

Private Function bufferLong(longNumber As Long) As Long
'Questa funzione restituisce il parametro in ingresso
    bufferLong = longNumber
End Function

Private Sub BrowseForFolderDirClick(ByVal hwndOwner As Long, ByVal uMSG As Long, ByVal lParam As Long, ByVal pData As Long)
Dim d As Long
Dim Found As Boolean
Found = False
If BFF_DoNotAllowPaths Then         'Se devo lavorare su cartelle non concesse
    Dim CurrentPath As String
    CurrentPath = String$(MAX_PATH, 0)
    If SHGetPathFromIDList(lParam, CurrentPath) Then    'Se in questo momento  stata scelta una cartella valida
        For d = 0 To UBound(BFF_Paths)
            If UCase(Left(CurrentPath, Len(BFF_Paths(d)))) = UCase(BFF_Paths(d)) Then 'Se si cerca di aprire la cartella in lista
                Found = True
                'In questo caso cambio la cartella con quella precedente
                Call SendMessage(hwndOwner, BFFM_SETSELECTION, 1&, ByVal BFF_TempLastPath)
                'Eventualmente mando il messaggio impostato
                If BFF_MessageBox <> "" Then Call MsgBox(BFF_MessageBox)
                Exit For
            End If
        Next d
    End If
    'Call CoTaskMemFree(lParam)
End If
'Memorizzo l'ultima cartella scelta per poi ripristinarla se necessario
If Not Found Then
    BFF_TempLastPath = String(MAX_PATH, 0)
    Call SHGetPathFromIDList(lParam, BFF_TempLastPath)
End If
End Sub

Public Function AddToArray(strArray() As String, elemento As String, Optional OnlyIfNotAlreadyPresent As Boolean = False) As Boolean
'Aggiunge un elemento all'array di stringhe
'Restituisce false solo se:
'    stato richiesto di aggiungere solo se non c' e c'era
Dim NextPos As Long
Dim LeftPos As Long
On Error Resume Next
'Controllo se c' gi... se richiesto
'If OnlyIfNotAlreadyPresent Then
'    If CheckStrInStrArray(elemento, strArray) Then AddToArray = False: Exit Function
'End If
NextPos = UBound(strArray) + 1
LeftPos = LBound(strArray)
ReDim Preserve strArray(LeftPos To NextPos)
strArray(NextPos) = elemento
AddToArray = True
End Function

Private Function BrowseFolderCallbackProc(ByVal hwndOwner As Long, ByVal uMSG As Long, ByVal lParam As Long, ByVal pData As Long) As Long
    'Chiamata CallBack da usare con la funzione BrowseForFolder
    Dim tempString As String
    
    On Local Error Resume Next
    Select Case uMSG    'Scelgo che tipo di messaggio  giunto
        Case BFFM_INITIALIZED   'Inizializzazione
            If BFF_BrowseForFolderInitDir <> "" Then
                tempString = BFF_BrowseForFolderInitDir & Chr$(0)
                ' WParam  sar TRUE  se si specifica un path.
                '         sar FALSE se si specifica un pIDL.
                Call SendMessage(hwndOwner, BFFM_SETSELECTION, 1&, ByVal tempString)
            End If
        
        Case BFFM_SELCHANGED    'Selezione di una cartella
            'Meglio Chiamare una Procedura a parte che si potr
            'Modificare e usare a piacimento
            Call BrowseForFolderDirClick(hwndOwner, uMSG, lParam, pData)
    End Select
    
    BrowseFolderCallbackProc = 0
End Function

Private Sub fileNamePath(percorso As String, Optional ByRef fileName As String, Optional ByRef filePath As String)
'dato Percorso inserisce in fileName il nome del file, in filePath il percorso
'se Percorso  semplicemente il nome del file restituisce il nome del file
Dim tro As Long
Dim tro1 As Long
tro1 = 0
Do
    tro = tro1 + 1
    tro1 = InStr(tro, percorso, "\")
Loop While (tro1 <> 0)

tro = tro - 1

fileName = Right(percorso, Len(percorso) - tro)
filePath = Left(percorso, tro)
End Sub

Public Function getFilePath(percorso As String) As String
Dim temp As String
Call fileNamePath(percorso, , temp)
getFilePath = temp
End Function

